function DrawMap(height, graph, highlight_chain)
  
  height = height/5;

  [x,y] = meshgrid(1:size(height,1));
  checker_grid = 10;
  checker = repmat(double(mod(ceil(x / checker_grid),2) ~= mod(ceil(y / checker_grid),2)), [1,1,3])/2;

  surf(x,y, height, checker, 'EdgeColor', 'none'); colormap('gray');
  axis image off;
  view(108, 25)
  
%   hold on;
%   scatter3(graph.nodes(:,1), graph.nodes(:,2), 1+height(sub2ind(size(height), graph.nodes(:,1), graph.nodes(:,2))), 'ko', 'filled'); hold on;
%   [edge_i, edge_j] = find(graph.edges);
%   for i = 1:size(edge_i,1)
%     line( [graph.nodes(edge_i(i),1), graph.nodes(edge_j(i),1)], [graph.nodes(edge_i(i),2), graph.nodes(edge_j(i),2)] , 'color', [.5 .5 .5]);
%   end
  
  if nargin >= 3
    height_chain = 3+height(sub2ind(size(height), graph.nodes(highlight_chain,1), graph.nodes(highlight_chain,2)));
    line( [graph.nodes(highlight_chain,1), graph.nodes(highlight_chain,1)], [graph.nodes(highlight_chain,2), graph.nodes(highlight_chain,2)], [height_chain, height_chain], 'color', 'r', 'LineWidth', 5);
%     for i = 1:(length(highlight_chain)-1)
      
%     end
  end
  
  axis image;
  
end