clear all

im = imread('Data/Map.png');

colors = ['rgbcmyk'];


% imagesc(im); axis image; plotHelp_setsize(1,1,0.02) 
% 
% nodes = {};
% edges = {};
% for i = 1:5
%   [x,y] = ginput;
% 
%   nodes{i} = [x,y];
%   edges{i} = [[1:size(nodes{i},1)-1]', [2:size(nodes{i},1)]'];
%   
%   clf
%   imagesc(im); axis image; plotHelp_setsize(1,1,0.02)
%   hold on;
%   for j = 1:length(nodes)
%     V = nodes{j};
%     E = edges{j};
%     c = colors(j);
%     line([V(E(:,1),1), V(E(:,2),1)]', [V(E(:,1),2), V(E(:,2),2)]', 'Color', c, 'LineWidth', 2)
%     scatter(V(:,1), V(:,2), 50, [c,'o'], 'filled')
%     drawnow;
%   end
% 
% end
% 



% load bart
% 
% 
% c = 0;
% for j = 1:length(nodes)
%   edges{j} = edges{j} + c;
%   c = c + size(edges{j},1) + 1;
% end
% 
% 
% nodes = cat(1,nodes{:});
% edges = cat(1,edges{:});
% edge_mat = sparse(edges(:,1), edges(:,2), ones(size(edges(:,2))), size(nodes,1), size(nodes,1));
% edge_mat = edge_mat | edge_mat';
% 
% D  = distMat(nodes, nodes);
% [i,j] = find(triu(D < 40,1));
% keep = setdiff(1:size(nodes,1), j);
% 
% for ii = 1:length(i)
%   edge_mat(:,i(ii)) = edge_mat(:,i(ii)) | edge_mat(:,j(ii));
% end
% 
% nodes = nodes(keep,:);
% edge_mat = edge_mat(keep,keep);
% edge_mat = edge_mat | edge_mat';
% [i,j] = find(edge_mat); edges = [i,j];
% edges = unique(sort(edges, 2, 'ascend'), 'rows');
% 
% clf
% imagesc(im); axis image; plotHelp_setsize(1,1,0.02)
% hold on;
% V = nodes;
% V = V + normrnd(0, 1, size(V))*20;
% E = edges;
% for i = 1:size(E,1)
%   line([V(E(i,1),1), V(E(i,2),1)]', [V(E(i,1),2), V(E(i,2),2)]', 'Color', 'r', 'LineWidth', 2)
% end
% scatter(V(:,1), V(:,2), 50, ['bo'], 'filled')
% drawnow;
% 
% 
% frequencies = ones(size(edges,1),1);
% figure
% 
% while true
%   clf
%   imagesc(im); axis image; plotHelp_setsize(1,1,0.02)
%   hold on;
%   V = nodes;
%   E = edges;
%   for i = 1:size(E,1)
%     line([V(E(i,1),1), V(E(i,2),1)]', [V(E(i,1),2), V(E(i,2),2)]', 'Color', 'r', 'LineWidth', frequencies(i))
%   end
%   scatter(V(:,1), V(:,2), 50, ['bo'], 'filled')
%   drawnow;
% 
%   [x,y] = ginput(2);
%   if length(x) == 0
%     break
%   end
% 
%   p1 = [x(1), y(1)];
%   p2 = [x(2), y(2)];
% 
%   D = distMat(p1, nodes);
%   start_idx = find(D == min(D), 1, 'first');
%   D = distMat(p2, nodes);
%   end_idx = find(D == min(D), 1, 'first');
% 
%   [dist, path] = graphshortestpath(edge_mat, start_idx, end_idx);
%   idx = all(ismember(edges, path),2);
%   frequencies(idx) = frequencies(idx) + 1;
% end
% 
% save bart nodes edges edge_mat frequencies

% load bart
% 
% nodes = nodes ./ size(im,1);
% distances = sqrt(sum((nodes(edges(:,1),:) - nodes(edges(:,2),:)).^2,2));
% costs = distances ./ frequencies;
% 
% graph.nodes = nodes;
% graph.edges = sparse([edges(:,1); edges(:,2)], [edges(:,2); edges(:,1)], 1:(2*size(edges(:,2))), size(nodes,1), size(nodes,1));
% [i,j,v] = find(graph.edges);
% 
% [tf, loc] = ismember(sort([i,j], 2, 'ascend'), edges, 'rows');
% 
% graph.costs = costs(loc);
% 
% clf
% imagesc(im); axis image; plotHelp_setsize(1,1,0.02)
% hold on;
% V = nodes * size(im,1);
% E = edges;
% for i = 1:size(E,1)
%   line([V(E(i,1),1), V(E(i,2),1)]', [V(E(i,1),2), V(E(i,2),2)]', 'Color', 'r', 'LineWidth', frequencies(i))
% end
% scatter(V(:,1), V(:,2), 50, ['bo'], 'filled')
% drawnow;
% 
% [x,y] = ginput;
% label_names = {'School', 'Bob''s House', 'Fred''s House', 'El Farolito', 'Giant''s Stadium'};
% label_positions = [x,y];
% 
% save bart_graph graph label*

load bart_graph

label_positions = label_positions / size(im,1);

D = distMat(label_positions, graph.nodes);
[i,j] = find((D == repmat(min(D,[],2), 1, size(D,2)))');
graph.label_idx = i';
graph.label_name = label_names;

clf
imagesc([0,1], [0,1], im); axis image; plotHelp_setsize(1,1,0.02)
hold on;
V = graph.nodes;
[i,j] = find(graph.edges);
E = [i,j];
for i = 1:size(E,1)
  line([V(E(i,1),1), V(E(i,2),1)]', [V(E(i,1),2), V(E(i,2),2)]', 'Color', 'r', 'LineWidth', graph.costs(i)*70)
end
scatter(V(:,1), V(:,2), 50, ['bo'], 'filled')
axis image off;
drawnow;

for ii = 1:length(graph.label_idx)
  i = graph.label_idx(ii);
  text(graph.nodes(i,1)+.015, graph.nodes(i,2), graph.label_name{ii}, 'FontSize', 12, 'FontWeight', 'bold')
end

save bart_graph graph
