function orderChildren(nodes, children, start_node_idx, grandparent_i, parent_i)

global ordered_children

kids = children{parent_i};
if isempty(kids)
  ordered_children{parent_i} = [];
  return
end

if isempty(grandparent_i)
  offsets = nodes(kids,:) - repmat(nodes(parent_i,:), length(kids),1);
  [th] = cart2pol(offsets(:,1), offsets(:,2));
  th = mod(th, 2*pi);
  [sorted, sortidx] = sort(th, 'ascend');
  ordered_children{parent_i} = kids(sortidx);
else
  idx = [grandparent_i, kids];
  offsets = nodes(idx,:) - repmat(nodes(parent_i,:), length(idx),1);
  [th] = cart2pol(offsets(:,1), offsets(:,2));
  th = mod(th - th(1), 2*pi);
  [sorted, sortidx] = sort(th(2:end), 'ascend');
  ordered_children{parent_i} = kids(sortidx);
end

for kid = ordered_children{parent_i}
  orderChildren(nodes, children, start_node_idx, parent_i, kid);
end

