function [] = plotHelp_setSize(xMult, yMult, borderSize)
PLOTBASESIZE = 500;
PAPERBASESIZE = 6;
PLOTBORDERSIZE = 0.15;

  set(gca, 'PlotBoxAspectRatio', [xMult yMult 1])
  set(gcf, 'Position', get(gcf, 'Position') .* [1 1 0 0] + [0 0 PLOTBASESIZE*xMult PLOTBASESIZE*yMult]);
  if nargin < 3 | isempty(borderSize)
    borderSize = PLOTBORDERSIZE;
  end
  set(gca, 'Position', [borderSize borderSize 1-2*borderSize 1-2*borderSize]);
  set(gcf, 'PaperUnits', 'inches');
  set(gcf, 'PaperPosition', [0 0 PAPERBASESIZE*xMult PAPERBASESIZE*yMult]);   
end