
% M = 5;
% Epos = [0:0.1:M];
% dEpos = (2*M*s*sqrt( (s*E)./max(eps,(M-E)) ))./((s + (E*s)./(M-E)).^2);

E_max = 5;
E_sigma = 1;
E = [0:0.1:E_max];
dEpos = ((E-E_max).^2)./(E_max*E_sigma);

% % Mountain Bike
% biker.K1 = 7.845;
% biker.K2 = 0.3872;
% biker.mass = 80;

% Road Bike
K1 = 3.509;
K2 = 0.2581;
mass = 75;

% slope is fraction, acceleration is meters/sec/sec, mass is kg, speed is
% meters/sec
% dE is joules/second

dE = speed .* (K1 + (K2 * speed.^2) + (10.32*mass.*(slope + 1.01/GRAVITY .* acceleration)));

% dSpeed/dt = acceleration
% distance = speed * time
% time = distance/speed

% NOTE: Speed of the bike and "speed" along the graph aren't the same, when
% there is incline. Throw in a sine somewhere.

% minimize(E + lambda*time)

% dE(speed, acceleration, slope) = dEpos(E) + dEneg(speed, acceleration, slope)


% Input: - a length of road, with height for all points.
%        - Energy stats for the rider

% Driver can't adjust his speed, only the acceleration.

% Driver would probably pick an acceleration such that he can make the trip
% without exhausting himself, or without getting within some distance of
% exhaustion. We have a "goal exhaustion". We can say this is zero.

% Driver want to maintain a certain speed, and doesn't care about going
% faster. We have a "goal speed".

% Driver is aware of the hill, so he doesn't pick accelarations that will
% bring him to below his "goal exhaustion".

% Driver has a minimum speed, and if he goes too slow, he falls over. This
% can probably be ignored.

% Maybe instead of "goal exhaustion", we can have a maximum energy
% expenditure, and so we never accelerate such that we go over that energy
% expenditure. This is *more coarse*, less good.

% Given the road, and a biker (which includes an energy/time preference),
% we want to minimize some linear combination of energy and time. But we
% want to find the minimum cost for the entire route, not for just a single
% road. The search takes care of this, I guess, so we just need to compute
% the minimum cost of a road-step

% Speed carries over between steps, weirdness.

% Coarse model:
% State is (position, time, speed). Cost is (time + lambda*energy)



