function treeLay(nodes, costs, children, branching, start_node_idx, edge_idx, grandparent_i, parent_i)

global node_theta_range
theta_range = node_theta_range(parent_i,:);

kids = children{parent_i};
if isempty(kids)
  return
end

if isempty(grandparent_i)
  offsets = nodes(kids,:) - repmat(nodes(parent_i,:), length(kids),1);
  [th] = cart2pol(offsets(:,1), offsets(:,2));
  th = mod(th, 2*pi);
  [sorted, sortidx] = sort(th, 'ascend');
else
  idx = [grandparent_i, kids];
  offsets = nodes(idx,:) - repmat(nodes(parent_i,:), length(idx),1);
  [th] = cart2pol(offsets(:,1), offsets(:,2));
  th = mod(th - th(1), 2*pi);
  [sorted, sortidx] = sort(th(2:end), 'ascend');
end
kids = kids(sortidx);

% [th, r] = cart2pol(nodes(kids,1), nodes(kids,2));
% th = mod(th, 2*pi);
% [sorted, sortidx] = sort(th, 'ascend');
% kids = kids(sortidx);

amounts = branching(kids);
if isempty(amounts)
  amounts = 1;
end
theta_fenceposts = [0; cumsum(amounts) ./ sum(amounts)] * (theta_range(2)-theta_range(1)) + theta_range(1);

node_theta_range(kids,:) = [theta_fenceposts(1:end-1), theta_fenceposts(2:end)];

% theta_step = (theta_range(2) - theta_range(1)) / (length(kids));
% kid_thetas = ([1:length(kids)]'-.5) .* theta_step + theta_range(1);
% kid_lengths = costs(kids);

% [x,y] = pol2cart(theta_centers, kid_lengths);
% sub_nodes_warp = [x,y];
% nodes_warp(kids,:) = sub_nodes_warp;

for kid_i = 1:length(kids)
  treeLay(nodes, costs, children, branching, start_node_idx, edge_idx, parent_i, kids(kid_i));
%   v = ~isnan(nodes_warp_kids);
%   nodes_warp(v) = nodes_warp_kids(v);
%   nodes_warp(kids(kid_i),:) = nodes_warp_kids(kids(kid_i),:);
%   nodes_warp(children{kids(kid_i)},:) = sub_nodes_warp_kids;
end

% renderTree(nodes_warp, start_node_idx, costs, edge_idx);

