function XYZ = LatLon2XYZ(lat, lon) %Input in degrees
  CONSTANTS;
  lat = RADIANS_PER_DEGREE * lat;
  lon = RADIANS_PER_DEGREE * lon;
  
  XYZ = EARTH_RADIUS*[cos(lat) .* cos(lon), ...
    cos(lat) .* sin(lon), ...
    sin(lat)];
end