
CONSTANTS;

rand('twister',5489);
n_paths = 10;

biker = BIKERS{1};
paths = {};
costs = [];
part_costs = {};
accelerations = {};
part_stats = {};

for i = 1:n_paths
  paths{i} = makePath_random;
  [costs(i), part_costs{i}, accelerations{i}, part_stats{i}] = minCost(paths{i}, biker);
end

g = [];
a = [];
d = [];
o = [];
for i = 1:n_paths
  g = [g; paths{i}.grade/max(paths{i}.grade)];
  a = [a; accelerations{i}/max(accelerations{i})];
  d = [d; paths{i}.arc_dist];
  o = [o; [1:length(accelerations{i})]'/length(accelerations{i})];
end

scatter3(g, o, a)
xlabel('grade')
ylabel('distance')
zlabel('acceleration')
