function im = makeColorChecker(sz)

span = [-.8, .8];
step = (span(2) - span(1))/2;

idx = span(1):((span(2)-span(1))/(sz-1)):span(2);
[u,v] = meshgrid(idx, idx);
checker = 0.2 * double((mod(2*u, step) > step/2) ~= (mod(2*v, step) > step/2)) + 0.4;
im = double(yuv2rgb(255*cat(3, checker, u, v)))/255;
