function grid = point2grid(point)

grid = zeros(size(point)+1);
grid(2:end-1,2:end-1) = (point(2:end,2:end) + point(1:end-1,2:end) + point(2:end,1:end-1) + point(1:end-1,1:end-1))/4;

padx1 = 2*point(1,:) - point(2,:);
padx2 = 2*point(end,:) - point(end-1,:);
pady1 = 2*point(:,1) - point(:,2);
pady2 = 2*point(:,end) - point(:,end-1);

grid11 = (point(:,1) + pady1)/2;
grid(2:end-1,1) = (grid11(1:end-1) + grid11(2:end))/2;

grid12 = (point(:,end) + pady2)/2;
grid(2:end-1,end) = (grid12(1:end-1) + grid12(2:end))/2;

grid21 = (point(1,:) + padx1)/2;
grid(1,2:end-1) = (grid21(1:end-1) + grid21(2:end))/2;

grid22 = (point(end,:) + padx2)/2;
grid(end,2:end-1) = (grid22(1:end-1) + grid22(2:end))/2;

grid(1,1) = point(1,1) + ((padx1(1) - point(1,1)) + (pady1(1) - point(1,1)))/2;
grid(1,end) = point(1,end) + ((padx1(end) - point(1,end)) + (pady2(1) - point(1,end)))/2;

grid(end,1) = point(end,1) + ((padx2(1) - point(end,1)) + (pady1(end) - point(end,1)))/2;
grid(end,end) = point(end,end) + ((padx2(end) - point(end,end)) + (pady2(end) - point(end,end)))/2;
