function [D,O] = thetaDist(th1, th2)
% D = distance in radians
% O = side of th1 on which th2 falls (1 == geq, 0 == less)

d = mod(th1, 2*pi) - mod(th2, 2*pi);
D = min(min(abs(d), abs(d + 2*pi)), abs(d - 2*pi));
O = mod(d, 2*pi) >= pi;